package br.ufg.inf.sh;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.logging.Level;

import ch.ethz.inf.vs.californium.CaliforniumLogger;
import ch.ethz.inf.vs.californium.coap.MediaTypeRegistry;
import ch.ethz.inf.vs.californium.coap.Request;

/**
 *
 * @author brunoos
 */
public class BulbPanel extends javax.swing.JPanel {

    private Bulb bulb;

    static {
		CaliforniumLogger.initialize();
		CaliforniumLogger.setLevel(Level.WARNING);
	}
	
    public BulbPanel(Bulb b) {
        initComponents();
        bulb = b;
        identificador.setText(b.getId());
    }

    public void setStatus(String str) {
        jStatus.setText(str);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jStatus = new javax.swing.JLabel();
        btOn = new javax.swing.JButton();
        btOff = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        identificador = new javax.swing.JLabel();
        btRefresh = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(500, 500));

        jLabel1.setText("Status:");

        jStatus.setText("???");

        btOn.setText("On");
        btOn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onPress(evt);
            }
        });

        btOff.setText("Off");
        btOff.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                offPress(evt);
            }
        });

        jLabel2.setText("Identificador:");

        identificador.setText("???");

        btRefresh.setText("Status");
        btRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                statusPress(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(identificador, javax.swing.GroupLayout.DEFAULT_SIZE, 148, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btOn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btOff)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btRefresh)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jStatus, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(identificador))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jStatus))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btOn)
                    .addComponent(btOff)
                    .addComponent(btRefresh))
                .addContainerGap(403, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void onPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onPress
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = bulb.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/lamp/control?turn=on");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_onPress

    private void offPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_offPress
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = bulb.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/lamp/control?turn=off");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_offPress

    private void statusPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_statusPress
    	Request request = Request.newGet();
    	URI uri = null;
		try {
			String addr = bulb.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/lamp/status");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
		try {
			bulb.setResponse(request.waitForResponse());
			bulb.process(null);
		} catch (InterruptedException e) {
			System.err.println("Failed to receive response: " + e.getMessage());
		}
    }//GEN-LAST:event_statusPress


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btOff;
    private javax.swing.JButton btOn;
    private javax.swing.JButton btRefresh;
    private javax.swing.JLabel identificador;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jStatus;
    // End of variables declaration//GEN-END:variables
}
