package br.ufg.inf.sh;

import java.net.URI;
import java.net.URISyntaxException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.logging.Level;

import ch.ethz.inf.vs.californium.CaliforniumLogger;
import ch.ethz.inf.vs.californium.coap.MediaTypeRegistry;
import ch.ethz.inf.vs.californium.coap.Request;

/**
 *
 * @author gttei
 */
public class RadioPanel extends javax.swing.JPanel {

    private Radio radio;

    static {
		CaliforniumLogger.initialize();
		CaliforniumLogger.setLevel(Level.WARNING);
	}
    
    /**
     * Creates new form RadioPanel
     */
    public RadioPanel(Radio r) {
        initComponents();
        radio = r;
        identificador.setText(radio.getId());
    }

    public void setChannel(float f) {
        tfCanal.setText(Float.toString(f));
    }

    public void setStatus(byte s) {
        tfStatus.setText(s == Util.TURN_OFF ? "Off" : "On");
    }

    public void setVolume(int v) {
        jsVolume.setValue(v);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btSetVolume = new javax.swing.JButton();
        btGetCanal = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jsVolume = new javax.swing.JSlider();
        btOff = new javax.swing.JButton();
        btClean = new javax.swing.JButton();
        btSend = new javax.swing.JButton();
        btRefresh = new javax.swing.JButton();
        tfStatus = new javax.swing.JLabel();
        btOn = new javax.swing.JButton();
        identificador = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        btGetVolume = new javax.swing.JButton();
        tfCanal = new javax.swing.JTextField();
        bt1 = new javax.swing.JButton();
        bt2 = new javax.swing.JButton();
        bt3 = new javax.swing.JButton();
        bt4 = new javax.swing.JButton();
        bt5 = new javax.swing.JButton();
        bt6 = new javax.swing.JButton();
        bt7 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        bt8 = new javax.swing.JButton();
        bt0 = new javax.swing.JButton();
        bt9 = new javax.swing.JButton();
        btDot = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jSeparator3 = new javax.swing.JSeparator();
        jSeparator4 = new javax.swing.JSeparator();

        btSetVolume.setText("Set");
        btSetVolume.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSetVolumeActionPerformed(evt);
            }
        });

        btGetCanal.setText("?");
        btGetCanal.setToolTipText("Get");
        btGetCanal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btGetCanalActionPerformed(evt);
            }
        });

        jLabel3.setText("Volume:");

        jsVolume.setValue(0);

        btOff.setText("Off");
        btOff.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btOffoffPress(evt);
            }
        });

        btClean.setText("X");
        btClean.setToolTipText("Clear");
        btClean.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btCleanActionPerformed(evt);
            }
        });

        btSend.setText("!");
        btSend.setToolTipText("Send");
        btSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSendActionPerformed(evt);
            }
        });

        btRefresh.setText("Get");
        btRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btRefreshstatusPress(evt);
            }
        });

        tfStatus.setText("?");

        btOn.setText("On");
        btOn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btOnonPress(evt);
            }
        });

        identificador.setText("?");

        jLabel1.setText("Status:");

        jLabel4.setText("Canal:");

        btGetVolume.setText("Get");
        btGetVolume.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btGetVolumeActionPerformed(evt);
            }
        });

        tfCanal.setEditable(false);
        tfCanal.setBackground(new java.awt.Color(255, 255, 255));

        bt1.setText("1");
        bt1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt1ActionPerformed(evt);
            }
        });

        bt2.setText("2");
        bt2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt2ActionPerformed(evt);
            }
        });

        bt3.setText("3");
        bt3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt3ActionPerformed(evt);
            }
        });

        bt4.setText("4");
        bt4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt4ActionPerformed(evt);
            }
        });

        bt5.setText("5");
        bt5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt5ActionPerformed(evt);
            }
        });

        bt6.setText("6");
        bt6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt6ActionPerformed(evt);
            }
        });

        bt7.setText("7");
        bt7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt7ActionPerformed(evt);
            }
        });

        jLabel2.setText("Identificador:");

        bt8.setText("8");
        bt8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt8ActionPerformed(evt);
            }
        });

        bt0.setText("0");
        bt0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt0ActionPerformed(evt);
            }
        });

        bt9.setText("9");
        bt9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt9ActionPerformed(evt);
            }
        });

        btDot.setText(".");
        btDot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btDotActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator1)
            .addComponent(jSeparator2)
            .addComponent(jSeparator3, javax.swing.GroupLayout.Alignment.TRAILING)
            .addComponent(jSeparator4)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(identificador, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(tfStatus, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btOn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btOff)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btRefresh)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jsVolume, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(btSetVolume)
                                .addGap(18, 18, 18)
                                .addComponent(btGetVolume)
                                .addGap(0, 8, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addGap(4, 4, 4)
                        .addComponent(tfCanal))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(bt4)
                                .addGap(18, 18, 18)
                                .addComponent(bt5)
                                .addGap(18, 18, 18)
                                .addComponent(bt6))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(bt1)
                                .addGap(18, 18, 18)
                                .addComponent(bt2)
                                .addGap(18, 18, 18)
                                .addComponent(bt3))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(bt7)
                                        .addGap(18, 18, 18)
                                        .addComponent(bt8))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(btClean)
                                        .addGap(18, 18, 18)
                                        .addComponent(bt0))
                                    .addComponent(btGetCanal, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(bt9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(btSend, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(btDot, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(identificador))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(tfStatus))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btOn)
                    .addComponent(btRefresh)
                    .addComponent(btOff))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jsVolume, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btSetVolume)
                    .addComponent(btGetVolume))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(tfCanal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bt1)
                    .addComponent(bt2)
                    .addComponent(bt3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bt4)
                    .addComponent(bt5)
                    .addComponent(bt6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bt7)
                    .addComponent(bt8)
                    .addComponent(bt9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(bt0)
                    .addComponent(btClean)
                    .addComponent(btDot))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btSend)
                    .addComponent(btGetCanal))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(84, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btGetCanalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btGetCanalActionPerformed
    	Request request = Request.newGet();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/radio/status?get=station");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
		try {
			radio.setResponse(request.waitForResponse(), Util.RESP_GET_STATION);
			radio.process(null);
		} catch (InterruptedException e) {
			System.err.println("Failed to receive response: " + e.getMessage());
		}
    }//GEN-LAST:event_btGetCanalActionPerformed

    private void btOffoffPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btOffoffPress
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/radio/control?turn=off");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_btOffoffPress

    private void btCleanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btCleanActionPerformed
        tfCanal.setText("");
    }//GEN-LAST:event_btCleanActionPerformed

    private void btSendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSendActionPerformed
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			float s = (float) Float.parseFloat(tfCanal.getText());
			uri = new URI("coap://["+addr+"]:5683/radio/control?station="+s);
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_btSendActionPerformed

    private void btRefreshstatusPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btRefreshstatusPress
    	Request request = Request.newGet();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/radio/status?get=all");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
		try {
			radio.setResponse(request.waitForResponse(), Util.RESP_GET_STATUS);
			radio.process(null);
		} catch (InterruptedException e) {
			System.err.println("Failed to receive response: " + e.getMessage());
		}
    }//GEN-LAST:event_btRefreshstatusPress

    private void btOnonPress(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btOnonPress
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/radio/control?turn=on");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_btOnonPress

    private void bt1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt1ActionPerformed
        tfCanal.setText(tfCanal.getText() + "1");
    }//GEN-LAST:event_bt1ActionPerformed

    private void bt2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt2ActionPerformed
        tfCanal.setText(tfCanal.getText() + "2");
    }//GEN-LAST:event_bt2ActionPerformed

    private void bt3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt3ActionPerformed
        tfCanal.setText(tfCanal.getText() + "3");
    }//GEN-LAST:event_bt3ActionPerformed

    private void bt4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt4ActionPerformed
        tfCanal.setText(tfCanal.getText() + "4");
    }//GEN-LAST:event_bt4ActionPerformed

    private void bt5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt5ActionPerformed
        tfCanal.setText(tfCanal.getText() + "5");
    }//GEN-LAST:event_bt5ActionPerformed

    private void bt6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt6ActionPerformed
        tfCanal.setText(tfCanal.getText() + "6");
    }//GEN-LAST:event_bt6ActionPerformed

    private void bt7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt7ActionPerformed
        tfCanal.setText(tfCanal.getText() + "7");
    }//GEN-LAST:event_bt7ActionPerformed

    private void bt8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt8ActionPerformed
        tfCanal.setText(tfCanal.getText() + "8");
    }//GEN-LAST:event_bt8ActionPerformed

    private void bt0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt0ActionPerformed
        tfCanal.setText(tfCanal.getText() + "0");
    }//GEN-LAST:event_bt0ActionPerformed

    private void bt9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt9ActionPerformed
        tfCanal.setText(tfCanal.getText() + "9");
    }//GEN-LAST:event_bt9ActionPerformed

    private void btDotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btDotActionPerformed
        tfCanal.setText(tfCanal.getText() + ".");
    }//GEN-LAST:event_btDotActionPerformed

    private void btGetVolumeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btGetVolumeActionPerformed
    	Request request = Request.newGet();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			uri = new URI("coap://["+addr+"]:5683/radio/status?get=volume");
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
		try {
			radio.setResponse(request.waitForResponse(), Util.RESP_GET_VOLUME);
			radio.process(null);
		} catch (InterruptedException e) {
			System.err.println("Failed to receive response: " + e.getMessage());
		}
    }//GEN-LAST:event_btGetVolumeActionPerformed

    private void btSetVolumeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSetVolumeActionPerformed
    	Request request = Request.newPost();
    	URI uri = null;
		try {
			String addr = radio.getAddress().toString();
			addr = new String(addr.toCharArray(), 1, addr.length() - 1);
			byte v = (byte) jsVolume.getValue();
			uri = new URI("coap://["+addr+"]:5683/radio/control?volume="+v);
		} catch (URISyntaxException e) {
			System.err.println("Failed to parse URI: " + e.getMessage());
		}
		request.setURI(uri);
		request.getOptions().setContentFormat(MediaTypeRegistry.TEXT_PLAIN);
		
		try {
			request.send();
		} catch (Exception e) {
			System.err.println("Failed to execute request: " + e.getMessage());
		}
    }//GEN-LAST:event_btSetVolumeActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bt0;
    private javax.swing.JButton bt1;
    private javax.swing.JButton bt2;
    private javax.swing.JButton bt3;
    private javax.swing.JButton bt4;
    private javax.swing.JButton bt5;
    private javax.swing.JButton bt6;
    private javax.swing.JButton bt7;
    private javax.swing.JButton bt8;
    private javax.swing.JButton bt9;
    private javax.swing.JButton btClean;
    private javax.swing.JButton btDot;
    private javax.swing.JButton btGetCanal;
    private javax.swing.JButton btGetVolume;
    private javax.swing.JButton btOff;
    private javax.swing.JButton btOn;
    private javax.swing.JButton btRefresh;
    private javax.swing.JButton btSend;
    private javax.swing.JButton btSetVolume;
    private javax.swing.JLabel identificador;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSlider jsVolume;
    private javax.swing.JTextField tfCanal;
    private javax.swing.JLabel tfStatus;
    // End of variables declaration//GEN-END:variables
}
