package br.ufg.inf.sh;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

/**
 *
 * @author brunoos
 */
public class MapPanel extends javax.swing.JPanel {

    private BufferedImage img;

    /**
     * Creates new form PlantaPane
     */
    public MapPanel() {
        initComponents();
        try {
            img = ImageIO.read(ClassLoader.getSystemResourceAsStream("br/ufg/inf/sh/home.jpg"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void paint(Graphics g) {
        g.drawImage(img, 50, 50, null);
        for (Appliance a : ApplianceDAO.getInstance().getAppliances()) {
            a.drawImage(g);
        }
    }

    private Appliance find(Point p) {
        for (Appliance a : ApplianceDAO.getInstance().getAppliances()) {
            if (a.getArea().contains(p)) {
                return a;
            }
        }
        return null;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 768, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 430, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        Appliance a = find(evt.getPoint());
        if (a != null) {
            SmartHome.getInstance().setAppliance(a);
        }
    }//GEN-LAST:event_formMouseClicked


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
